let uploadStatusDiv = document.getElementById("uploadStatusDiv");
let uploadText = document.getElementById("uploadText");
let uploadButton = document.getElementById("uploadButton");
let uploadProcessingMessage = document.getElementById("uploadProcessingMessage");
let uploadFilename = document.getElementById("uploadFilename");
let uploadFileBytes = document.getElementById("uploadFileBytes");
let uploadFileInput = document.getElementById("file");

function humanFileSize(bytes, si = true, dp = 2) {
    const thresh = si ? 1000 : 1024;

    if (Math.abs(bytes) < thresh) {
        return bytes + ' B';
    }

    const units = si
        ? ['kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB']
        : ['KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'];
    let u = -1;
    const r = 10 ** dp;

    do {
        bytes /= thresh;
        ++u;
    } while (Math.round(Math.abs(bytes) * r) / r >= thresh && u < units.length - 1);


    return bytes.toFixed(dp) + ' ' + units[u];
}

function uploadFile() {
    let formdata = new FormData();
    formdata.append("file", uploadFileInput.files[0]);
    formdata.append("source", "web");
    let ajax = new XMLHttpRequest();
    ajax.upload.addEventListener("progress", progressHandler, false);
    ajax.addEventListener("load", responseHandler, false);
    ajax.addEventListener("error", responseHandler, false);
    ajax.addEventListener("abort", responseHandler, false);
    ajax.open("POST", "");
    ajax.send(formdata);
    uploadStatusDiv.hidden = false;
    uploadFileInput.disabled = true;
}

function progressHandler(event) {
    let percent = (event.loaded / event.total) * 100;

    if (percent >= 100) {
        uploadStatusDiv.hidden = true;
        uploadText.innerHTML = "Processing. Please wait...";
        uploadProcessingMessage.hidden = false;

        return;
    }

    uploadText.innerHTML = "Uploading: " + Math.round(percent) + "%";
    uploadFilename.innerHTML = uploadFileInput.files[0].name;
    uploadFileBytes.innerHTML = "Uploaded " + humanFileSize(event.loaded) + " of " + humanFileSize(event.total);
}

function responseHandler(event) {
    document.open('text/html').write(event.target.response).close();
}